// File automatically generated by ESPAM

#include "Plus214.h"
#include <stdlib.h>
#include <iostream>
#include "csdfNode.h"
#include "appMain.h"
#include "appFunc.h"
#include "fifo.h"
#include <cstddef>
#include "types.h"
#include <vector>
#include <string>
using namespace std;

Plus214::Plus214() : csdfNode() {
  //assign FIFO sizes
  IP0_fifo_size = 10;
  OP0_fifo_size = 10;

  int_params["input_dims"] = input_dims;
  int_params["input_dim_0"] = input_dim_0;
  int_params["output_dims"] = output_dims;
  int_params["output_dim_0"] = output_dim_0;
}
Plus214::~Plus214() {}

void Plus214::main(void *threadarg) {
  // create communication channel
  thread_info *thread_data;
  thread_data = (struct thread_info *) threadarg;
  fifo_buf* Plus214_IP0_buf_ptr = thread_data->get_fifo_buf_by_dst("Plus214_IP0");
 
  fifo_buf* Plus214_OP0_buf_ptr = thread_data->get_fifo_buf_by_src("Plus214_OP0");
 
 
  setaffinity(thread_data->core_id);
  // repetition parameters definition
  int q = 1;
  int phase_len = 1;
  int phase; 
 
  // while (1) {
    // loop over the repetitions number
    for (int rep = 0; rep < q ; rep ++) {
      phase = rep % phase_len;

      //reading
      //max tokens port IP0
      int IP0_tokens = 10;
 
      // readSWF_CPU to input
      if ( IP0_tokens > 0 )
        readSWF_CPU(Plus214_IP0_buf_ptr->fifo, &input[0], IP0_tokens, Plus214_IP0_buf_ptr->fifo_size);

      //execution
        for (int i = 0; i < 10; i++) {
        appFunc::execute(std::string("AddConst"),&input[0], nullptr, &output[0], &int_params);
      }

      //writing
      //max tokens port OP0
      int OP0_tokens = 10;
 
      // writeSWF_CPU to output
      if ( OP0_tokens > 0 )
        writeSWF_CPU(Plus214_OP0_buf_ptr->fifo, &output[0], OP0_tokens, Plus214_OP0_buf_ptr->fifo_size);
    }// loop over the phases
  cout<<" Plus214 finished! "<<endl;
  //} while (1)
} // main
